SystemOrganization addCategory: #'SleepyCoders-WalkieTalkie'!

Object subclass: #WalkieTalkie
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SleepyCoders-WalkieTalkie'!

!WalkieTalkie methodsFor: 'initialization' stamp: 'imy 4/16/2012 02:39'!
initializeAsListenerOnIP: ip port: port
	[
		|socket|
		socket := Socket newTCP.
		[session isNil] whileTrue:
		[
			socket listenOn: port backlogSize: 50 interface: ip.
			session := socket waitForAcceptFor: 60.
			Processor yield.
		]
	] fork.! !

!WalkieTalkie methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/16/2012 01:54'!
initializeAsTalkerToHost:host port: port
	session := Socket newTCP.
  	session connectToHostNamed: host port: port.! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 02:27'!
paired
"returns true if walkie is paird with another one. ei session ivar is set up"

	^(session=nil) not! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'YuriyTymchuk 4/16/2012 02:44'!
read
"reads data available on the walkie"
	
	^ReferenceStream unStream: session receiveData.! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'YuriyTymchuk 4/16/2012 02:41'!
send: data
"Send data to the other walkie"

session sendSomeData: (ReferenceStream streamedRepresentationOf:  data).! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 02:26'!
unread
"Returns true if walkie has unread data"

	^session dataAvailable.! !
